#include "button.h"

using namespace std;

CButton::CButton(SDL_Rect& coord_, const int& type_button_, const float& deep_, const float& coef_resol_) : ODraw_button_off(NULL), ODraw_button_on(NULL), CInteractive_img(true, NULL, coord_, deep_, coef_resol_) {

   // we create the default button : YES, NO or OK

   try {

      switch(type_button_) {

         case YES :
            ODraw_button_off = new CDraw(IMG_PATH + string("buttons/button_yes_off.png"), object_properties(), coef_resol);
            ODraw_button_on = new CDraw(IMG_PATH + string("buttons/button_yes_on.png"), object_properties(), coef_resol);
         break;

         case NO :
            ODraw_button_off = new CDraw(IMG_PATH + string("buttons/button_no_off.png"), object_properties(), coef_resol);
            ODraw_button_on = new CDraw(IMG_PATH + string("buttons/button_no_on.png"), object_properties(), coef_resol);
         break;

         case OK :
            ODraw_button_off = new CDraw(IMG_PATH + string("buttons/button_ok_off.png"), object_properties(), coef_resol);
            ODraw_button_on = new CDraw(IMG_PATH + string("buttons/button_ok_on.png"), object_properties(), coef_resol);
         break;
      }
   }
   catch(string caught) {
      delete(ODraw_button_off);
      delete(ODraw_button_on);
   }

   get_object_properties(ODraw_button_off->object_properties());
}

CButton::~CButton() {

   delete ODraw_button_off;
   delete ODraw_button_on;

}

