#include"dynamic.h"

CDynamic::CDynamic(CDynamic_Object& d_obj_) : potential_energy(0.0), d_obj(&d_obj_) {

   // We get the object psoition
   r = d_obj->dyn_obj.p;

}

void CDynamic::check(const float& ground, const float& limit_glue, const float& y_gr, const float& scrolling) {

   // ground vector
   TVector2d<float> gr;

   // if we are on the ground
   if(y_gr) {

      gr.x = d_obj->dyn_obj.w.y * ground;
      gr.y = -d_obj->dyn_obj.w.y * ground; 

      // to stop moving and glue object on the ground
      if(potential_energy < limit_glue)
         r.y = y_gr;

      potential_energy = 0.0;
   }
   else
      gr.x = gr.y = 0.0;

   // new result vector
   r.x += d_obj->dyn_obj.v.x + gr.x + scrolling;
   r.y += d_obj->dyn_obj.w.y * potential_energy + d_obj->dyn_obj.v.y + gr.y;

   potential_energy += 1.0;

   d_obj->dyn_obj.p = r;
}
