#include "dynamic_boss.h"

using namespace std;

CDynamic_Boss::CDynamic_Boss(const SDyn_obj& dyn_obj_, const int& nbr_lifes_, const int& max_ticks_time_to_turn_) : injured(false), active(false), time_to_turn(0), max_ticks_time_to_turn(max_ticks_time_to_turn_), injured_ticks(0), CDynamic_Object(dyn_obj_, 0, nbr_lifes_) {
}

bool CDynamic_Boss::blink_injured_read() {
   return injured;
}

void CDynamic_Boss::jump(const TVector2d<float>& jmp_) {

   TVector2d<float> jmp = jmp_;

   if(orientation_read())
      jmp.x = -jmp.x;

   accel(jmp);

}

void CDynamic_Boss::run(const float& v) {
   
   TVector2d<float> a(v, 0.0f);

   if(orientation_read())
      a.x = -a.x;

   accel(a);
}

bool CDynamic_Boss::check_(std::vector<std::shared_ptr<CDynamic_Fire> >& VFire_, const TVector2d<float>& p_tux_) {

   // when boss is injured once every two injured is true
   if(injured_ticks) {

      injured_ticks == MAX_INJURED_TICKS ? injured_ticks = 0 : ++injured_ticks;
      if(injured_ticks & 3)
         injured = true;
      else
         injured = false;

   }

   time_to_turn < max_ticks_time_to_turn ? time_to_turn++ : time_to_turn = 0;

   // to turn boss front of tux
   if(!time_to_turn)
      turn(p_tux_);

   // collision with a fire ?
   for(vector<shared_ptr<CDynamic_Fire> >::iterator i = VFire_.begin(); i != VFire_.end(); ++i)
      if(i->get()->life_read())
         IF_COLLISION(i->get()->position_read(), position_read(), COLLISION_BOSS_FIRE)
         {
            i->get()->death_eval();
            death_eval();
            i->get()->killall();
            return true;
         }

   return false;

}

bool CDynamic_Boss::slow_to_stop() {

   if(velocity_read().x < 1.0f && velocity_read().x > -1.0f) {
      stop();
      return true;
   }

   return false;
}

void CDynamic_Boss::death_eval() {

   // start injured timer
   ++injured_ticks;

   //nbr_lifes ? --nbr_lifes : death();

   if(nbr_lifes)
      nbr_lifes--;
   else
      CDynamic_Object::death_eval();

}

void CDynamic_Boss::activate() {
   active = true;
}

bool CDynamic_Boss::activated() {
   return active;
}

void CDynamic_Boss::time_swap_eval(const int& max) {
   max_ticks_time_to_turn = max;
}
