#include "dynamic_boss_bee.h"

using namespace std;

CDynamic_Boss_Bee::CDynamic_Boss_Bee(const SDyn_obj& dyn_obj_, const int& nbr_lifes_) :
                                           status_boss(BOSS_POSE), time_ticks(TIME_MAX), CDynamic_Boss(dyn_obj_, nbr_lifes_, 80) {
}

int CDynamic_Boss_Bee::status() {
   return status_boss;
}

void CDynamic_Boss_Bee::check(vector<shared_ptr<CDynamic_Fire> >& VFire_, const TVector2d<float>& p_tux) {

   if(time_ticks == TIME_MAX)
      time_swap_eval(80);

   if(time_ticks == 300)
      time_swap_eval(10);

   time_ticks?--time_ticks:time_ticks=TIME_MAX;

   // if boss is hurted by fire, fly up
   if(CDynamic_Boss::check_(VFire_, p_tux) && time_ticks > 200)
      time_ticks = TIME_MAX;

   // boss fly without attacks
   if(time_ticks > 300) {
      status_boss = BOSS_RUN;
      if(position_read().y > 300) {
         if(orientation_read())
            accel(TVector2d<float>(-velocity_read().x -4.0f, -1.2f));
         else
            accel(TVector2d<float>(-velocity_read().x + 4.0f, -1.2f));
      }
      else {
         if(orientation_read())
            accel(TVector2d<float>(-velocity_read().x -4.0f, .0f));
         else
            accel(TVector2d<float>(-velocity_read().x + 4.0f, .0f));
      }

      return;
   }

   status_boss = BOSS_ATTACK;

   if(time_ticks > 280)
      status_boss = BOSS_TURN;

   if(time_ticks > 200) {
/*
      if(p_tux.x < position_read().x) {
         if(!orientation_read())
            orientation_eval();
      }
      else {
         if(orientation_read())
            orientation_eval();
      }
*/
      if(position_read().y > 300) {
         if(orientation_read())
            accel(TVector2d<float>(-velocity_read().x -4.0f, -1.2f));
         else
            accel(TVector2d<float>(-velocity_read().x + 4.0f, -1.2f));
      }
      else {
         if(orientation_read())
            accel(TVector2d<float>(-velocity_read().x -4.0f, .0f));
         else
            accel(TVector2d<float>(-velocity_read().x + 4.0f, .0f));
      }
      return;
   }

   // the boss attacks
   if(position_read().y > 500.0f)
      accel(TVector2d<float>(0.0f, -1.6f));

}
