#include "dynamic_tux.h"

CDynamic_Tux::CDynamic_Tux(SDyn_obj dyn_obj_,
                       int nbr_lifes_,
                       int tux_level_) : tux_level(tux_level_), ticks_invincible(NBR_TICKS_INVINCIBLE), power(128), ticks_power(0), fire(false), nbr_coins(0), run(RUN_RIGHT_OFF), jump(STOP_JUMP), step_speed(1), CDynamic_Object(dyn_obj_, 0, nbr_lifes_) {
}

bool CDynamic_Tux::injured() {
   return ticks_invincible == NBR_TICKS_INVINCIBLE ? false : true;
}

void CDynamic_Tux::init_injure() {
  --ticks_invincible; 
}

void CDynamic_Tux::check() {

   if(ticks_invincible < NBR_TICKS_INVINCIBLE)
      --ticks_invincible; 

   if(ticks_invincible < 0)
      ticks_invincible = NBR_TICKS_INVINCIBLE; 
}

void CDynamic_Tux::power_eval(const bool& s) {

   if(s)
      power < 0 ? power = 0 : power -= 8;
   else {
      if(ticks_power > 10) {
         ticks_power = 0;
         power < 128 ? ++power : power = 128;
      }
      else
         ++ticks_power;
   }
}

int CDynamic_Tux::power_read() {
   return power;
}

int CDynamic_Tux::level_read() {
   return tux_level;
}

float CDynamic_Tux::level_speed() {
   return tux_level < 2 ? float(tux_level) / 2.0f + .5f : 1.0f;
}

void CDynamic_Tux::update_level(const bool& l) {

   l?++tux_level:--tux_level;

   if(tux_level > 2)
      tux_level = 2;
   if(tux_level < 0)
      tux_level = 0;
}

int CDynamic_Tux::run_read() {
   return run;
}

void CDynamic_Tux::run_eval(const int& v) {
   run = v;
}

int CDynamic_Tux::jump_read() {
   return jump;
}

void CDynamic_Tux::jump_eval(const int& v) {
   jump = v;
}

int CDynamic_Tux::step_speed_read() {
   return step_speed;
}

void CDynamic_Tux::step_speed_eval(const int& v) {
   step_speed = v;
}

int CDynamic_Tux::nbr_coins_read() {
   return nbr_coins;
}

void CDynamic_Tux::nbr_coins_update() {
   ++nbr_coins;
}

void CDynamic_Tux::reset_nbr_coins() {
   nbr_coins = 0;
}

void CDynamic_Tux::fire_eval() {
   fire = true;
}

bool CDynamic_Tux::fire_read() {
   if(fire) {
      fire = false;
      return true;
   }
   else
      return false;
}
