/********************************************************************************/
/* This class is abstract and used to show surfaces and eval mouse events on it */
/********************************************************************************/

/*
This file is part of Tuxworld.

    Tuxworld is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Tuxworld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Tuxworld.  If not, see <http://www.gnu.org/licenses/>.

Ce fichier fait partie de Tuxworld.

	Tuxworld est un logiciel libre ; vous pouvez le redistribuer ou le
	modifier suivant les termes de la GNU General Public License telle
	que publiée par la Free Software Foundation ; soit la version 3 de
	la licence, soit (à votre gré) toute version ultérieure.

	Tuxworld est distribué dans l'espoir qu'il sera utile, mais SANS
	AUCUNE GARANTIE ; pas même la garantie implicite de
	COMMERCIABILISABILITÉ ni d'ADÉQUATION à UN OBJECTIF PARTICULIER.
	Consultez la GNU General Public License pour plus de détails.

	Vous devez avoir reçu une copie de la GNU General Public License
	en même temps que Tuxworld ; si ce n'est pas le cas,
	consultez <http://www.gnu.org/licenses>.
*/

#ifndef GRAPHIC

#define GRAPHIC

#include <iostream>
#include "SDL.h"

static const SDL_Rect origins = {0, 0};

typedef struct S_Color4f {
   float r, g, b, a;
} Color4f;

class CGraphic {

   public :

      // constructors
      CGraphic(const SDL_Rect& coord_, const float& coef_resol_);
      CGraphic(SDL_Surface *p_surface, const SDL_Rect& p_object_rect, const float& coef_resol_);

      // destructor
      ~CGraphic();

      // return object properies, x, y, w, h
      SDL_Rect& object_properties();

      // object get new width and height properties from a surface
      void get_object_properties(SDL_Surface *surf_w_h);

      // object get new width and height properties from parameters
      void get_object_properties(const unsigned& w, const unsigned& h);

      // object get new width and height properties from a rect
      void get_object_properties(const SDL_Rect& obj_rect);

      // send surface properties : x, y, w, h
      SDL_Rect& surface_properties();

      //move object for the new coordinates
      void object_move(const int& x, const int& y);

   protected :

      // ratio resolution
      float coef_resol;

      // show object
      virtual void show();

      // eval mouse button on object cilc_on or cilc_off
      virtual bool eval(SDL_Event &ev);

      SDL_Surface *surface;

   private :

      SDL_Rect object_rect;
      SDL_Rect surface_rect;

};

#endif
