/*************************************************************************/
/* An interactive image is an image which we can activate or desactivate */
/*************************************************************************/

/*
This file is part of Tuxworld.

    Tuxworld is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Tuxworld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Tuxworld.  If not, see <http://www.gnu.org/licenses/>.

Ce fichier fait partie de Tuxworld.

	Tuxworld est un logiciel libre ; vous pouvez le redistribuer ou le
	modifier suivant les termes de la GNU General Public License telle
	que publiée par la Free Software Foundation ; soit la version 3 de
	la licence, soit (à votre gré) toute version ultérieure.

	Tuxworld est distribué dans l'espoir qu'il sera utile, mais SANS
	AUCUNE GARANTIE ; pas même la garantie implicite de
	COMMERCIABILISABILITÉ ni d'ADÉQUATION à UN OBJECTIF PARTICULIER.
	Consultez la GNU General Public License pour plus de détails.

	Vous devez avoir reçu une copie de la GNU General Public License
	en même temps que Tuxworld ; si ce n'est pas le cas,
	consultez <http://www.gnu.org/licenses>.
*/

#ifndef INTERACTIVE_IMG
#define INTERACTIVE_IMG

#include <SDL/SDL_image.h>
#include "graphic.h"
#include "draw.h"

class CInteractive_img : public CGraphic {

   private :
      // the image is activated or not
      bool on_off;

   protected :

      // The constructor
      CInteractive_img(const bool& opengl_, SDL_Surface *surf, SDL_Rect& coord, const float& deep_, float coef_resol_);
      ~CInteractive_img();

      virtual void show_on();
      virtual void show_off();

      // the non activated image, and the activated image 
      SDL_Surface *image_off, *image_on;
      const float deep;

   public :

      // events
      bool eval(SDL_Event& ev);

};

#endif
