/**********/
/* Macros */
/**********/

/*
This file is part of Tuxworld.

    Tuxworld is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Tuxworld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Tuxworld.  If not, see <http://www.gnu.org/licenses/>.

Ce fichier fait partie de Tuxworld.

	Tuxworld est un logiciel libre ; vous pouvez le redistribuer ou le
	modifier suivant les termes de la GNU General Public License telle
	que publiée par la Free Software Foundation ; soit la version 3 de
	la licence, soit (à votre gré) toute version ultérieure.

	Tuxworld est distribué dans l'espoir qu'il sera utile, mais SANS
	AUCUNE GARANTIE ; pas même la garantie implicite de
	COMMERCIABILISABILITÉ ni d'ADÉQUATION à UN OBJECTIF PARTICULIER.
	Consultez la GNU General Public License pour plus de détails.

	Vous devez avoir reçu une copie de la GNU General Public License
	en même temps que Tuxworld ; si ce n'est pas le cas,
	consultez <http://www.gnu.org/licenses>.
*/

#ifndef MACROS
#define MACROS

#define IMG_PATH string("../share/imgs/")
#define SOUNDS_PATH string("../share/sounds/")
#define TRANS_POSITION(p_x) (game.rect_earth.x + (p_x))
#define RIGHT_SCREEN_POSITION (TRANS_POSITION(game.screen->w / game.coef_resol))
#define JAXIS 8000
#define POWER_INF 20
#define ZONE_BOSS_INF 13300
#define ZONE_BOSS_SUP 15500
#define X_ACTIVATE_BOSS 14000
#define LIMIT_GLUE 6.0f
#define TOLERANCE_GRND 40
#define CLOCK_TIME 150
#define CLOCK_TICKS 35
#define TUX_VELOCITY_MAX 8.0
#define Y_START_OBJECT 100.0
#define COLLISION_TUX_COIN 28
#define COLLISION_TUX_BOSS 80 
#define COLLISION_FIRE_ENEMY 16 
#define COLLISION_BOSS_FIRE 120 
#define X_SIZE_OUT 40
#define Y_SIZE_OUT 40
#define STEP_HEARTS 40
#define STEP_EARTH 2
#define STEP_SKY 1
#define COLLISION_TUX_ENEMY 16
#define COLLISION_TUX_NUTTS 32
#define NBR_LIFES 3
#define ACCEL_JUMP_TUX -20.0

#define RY_EARTH(o_x) (game.ry_earth.at(TRANS_POSITION(o_x)))
#define RESULTANTS_Y_EARTH(o_x) (game.resultants_y_earth.at(TRANS_POSITION(o_x)))
#define ANIM_MOVE_TO_CENTER(anim_o, obj) anim_o->object_move(round(obj->position_read().x) - anim_o->object_properties().w / 2, round(obj->position_read().y) - anim_o->object_properties().h);
#define IF_COLLISION(a,b,r) if(abs((a).x - (b).x) < r)if(abs((a).y - (b).y) < r)

#endif
